include,"style.i";
ticks_lower=0x001;
ticks_upper=0x002;
ticks_inward=0x008;
ticks_outward=0x010;
labels_lower=0x020;
labels_upper=0x040;
grid_full=0x080;
grid_origin=0x100;
font_courier=0n;
font_times=4n;
font_helvetica=8n;
font_symbol=12n;
font_newcentury=16n;
font_bold=1n;
font_italic=2n;
line_solid=1n;
line_dash=2n;
line_dot=3n;
line_dash_dot=4;
line_dash_dot_dot=5;
color_fg=-2n;
color_bg=-1n;
color_black=-3n;
color_white=-4n;
cm=0.0369886;
mm=0.00369886;
pt= 0.0013;
inch= 72.27*pt;
struct PaperType{
 double xmax,xmin; // Length of the horizontal edge of the paper in Munro NDC.
 double ymax,ymin; // Length of the vertical edge of the paper in Munro NDC.
 int    landscape; 
}
A4Portrait=PaperType(xmax=19*cm,xmin=1*cm,ymax=27.7*cm,ymin=1*cm,landscape=0n);
A4Landscape=PaperType(xmax=27.7*cm,xmin=1*cm,ymax=19*cm,ymin=1*cm,landscape=1n);
//LetterPortrait=PaperType(x=8.5*inch,y=11*inch,landscape=0n);
//LetterLandscape=PaperType(x=11*inch,y=8.5*inch,landscape=1n);

func NPC(xmin,xmax,ymin,ymax)
{extern Paper;
 return [xmin*Paper.xmax+Paper.xmin, xmax*Paper.xmax+Paper.xmin, 
      ymin*Paper.ymax+Paper.xmin, ymax*Paper.ymax+Paper.ymin];
}
Paper=A4Portrait; 

func plbox(system, horiz,hmjfreq,hmnfreq,hsmnfreq,fhmjtick,
                   vert ,vmjfreq,vmnfreq,vsmnfreq,fvmjtick)
{
 system.ticks.horiz.flags=flags(horiz);
 system.ticks.horiz.nMajor=hmjfreq;
 system.ticks.horiz.nMinor=hmnfreq;
 system.ticks.horiz.logAdjMinor=hmnfreq;
 system.ticks.horiz.logAdjMajor=fhmjtick;

system.ticks.vert.flags=flags(vert);
 system.ticks.vert.nMajor=vmjfreq;
 system.ticks.vert.nMinor=vmnfreq;
 system.ticks.vert.logAdjMinor=vmnfreq;
 system.ticks.vert.logAdjMajor=fvmjtick;
}

func plmt(text, x, y,color=,font=,height=,opaque=,orient=,justify=,deltax=,deltay=)
/* DOCUMENT plmt, text, x, y
     same as plt, but in normalized coordinates relative to the system 
     described in "system". The tosys= keyword is not valid.
   KEYWORDS: color, font, height, opaque, orient, justify
   SEE ALSO: plt,plt1,pltitle
 */
{ port= viewport();
if (is_void(deltax)) deltax=0.;
if (is_void(deltay)) deltay=0.;
plt,text,deltax+(port(2)-port(1))*x+port(1),deltay+(port(4)-port(3))*y+port(3),color=color,font=font,height=height,
      opaque=opaque,orient=orient,justify=justify;
}

func pljoin(x1,y1,x2,y2,legend=, hide=,type=, width=,color=, closed=, smooth=,
marks=, marker=, mspace=, mphase=,rays=, arrowl=, arroww=,rspace=, rphase=)
/* DOCUMENT func pljoin(x1,y1,x2,y2)
   Joins the points (of type double) (x1,y1) and (x2,y2).
See also: plg
*/
{
plg,[y1,y2],[x1,x2],legend=legend, hide=hide,type=type, width=width, 
 color=color, closed=closed, smooth=smooth,marks=marks, marker=marker, 
 mspace=mspace, mphase=mphase,rays=rays, arrowl=arrowl, arroww=arroww,
 rspace=rspace, rphase=rphase;
}

func plmg(x1,y1,x2,y2,legend=, hide=,type=, width=,color=, closed=, smooth=,
marks=, marker=, mspace=, mphase=,rays=, arrowl=, arrow=,rspace=, rphase=,msize=)
/* DOCUMENT func pljoin(x1,x2,y1,y2)
   Joins the points (of type double) (x1,y1) and (x2,y2).
See also: pllsty, plcol, plwid.
*/
{port= viewport();
 sys=plsys(0);
plg,[(port(4)-port(3))*y1+port(3),(port(4)-port(3))*y2+port(3)],
    [(port(2)-port(1))*x1+port(1),(port(2)-port(1))*x2+port(1)],
  legend=legend, hide=hide,type=type, width=width, 
 color=color, closed=closed, smooth=smooth,marks=marks, marker=marker, 
 mspace=mspace, mphase=mphase,rays=rays, arrowl=arrowl, arroww=arrow,
 rspace=rspace, rphase=rphase, msize=msize;
plsys,sys;
}

// Sets up the default coordinate system
  landscape= Paper.landscape;
  default_line= GpLineAttribs(color= color_fg,  type= line_solid,  width= 1.0);
  default_text= GpTextAttribs(
    color= -2,  font= font_times,  height= 12*pt,
    orient= 0,  alignH= 0,  alignV= 0,  opaque= 0);
  default_ltxt= GpTextAttribs(
    color= -2,  font= font_times,  height= 9*pt,
    orient= 0,  alignH= 1,  alignV= 1,  opaque= 0);
  default= GfakeSystem(
    viewport=plstick(Paper,2,2,1,2,0,0,0,0),
    ticks= GaTickStyle(
      horiz= GaAxisStyle(
        nMajor=10, nMinor=40.0, logAdjMajor=80.0, logAdjMinor=1.2,
        nDigits=0, gridLevel=1, 
        flags=ticks_lower+ticks_upper+ticks_inward+labels_lower,
        tickOff=0.5*pt,
        labelOff=5*pt,
        tickLen= [9*pt, 5*pt, 3*pt, 5*pt, 5*pt],
        tickStyle= default_line,
        gridStyle= GpLineAttribs(color= color_fg,  type= line_dot,  width= 1.0),
        textStyle= default_text,
        xOver= 0.395,  yOver= 0.370),
      vert= GaAxisStyle(
        nMajor=10, nMinor=20.0, logAdjMajor=1.2, logAdjMinor=1.2,
        nDigits=2, gridLevel=1,
        flags=ticks_lower+ticks_upper+ticks_inward+labels_lower,
        tickOff=0.5*pt,
        labelOff=3*pt,
        tickLen= [9*pt, 5*pt, 3*pt, 3*pt, 3*pt],
        tickStyle= default_line,
        gridStyle= GpLineAttribs(color= color_fg,  type= line_dot,  width= 1.0),
        textStyle= default_text,
        xOver= 0.150,  yOver= 0.370),
      frame= 1,
      frameStyle= GpLineAttribs(color= color_fg,  type= line_solid,  width= 2.0)));
  default_legb= GeLegendBox(
    x= 0.04698,  y= 0.360,  dx= 0.3758,  dy= 0.0,
    textStyle= default_ltxt, nchars= 36,  nlines= 20,  nwrap= 2);
  default_clegb= GeLegendBox(
    x= 0.6182,  y= 0.8643,  dx= 0.0,  dy= 0.0,
    textStyle= default_ltxt, nchars= 14,  nlines= 28,  nwrap= 1);
  legends= default_legb;
  clegends= default_clegb;
